var sqlite3 = require('sqlite3');
var open = require('sqlite').open;

var repository = {
    create: async (entity) => {
        // Inserts entity in db table, id should be missing and autogenerated
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        let problem = await db.run('INSERT INTO problem (name, domain_id) VALUES (@name, @domain_id)',
            { '@name': entity.name, '@domain_id': entity.domain_id });

        await db.close();
        return { id: problem.lastID };
    },
    update: async (entity) => {
        // Inserts entity in db table, id should be missing and autogenerated
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        let problem = await db.run('UPDATE problem SET name = @name, domain_id = @domain_id WHERE id = @id',
        { '@name': entity.name, '@domain_id': entity.domain_id, '@id': entity.id });

        await db.close();
        return { id: problem.lastID };
    },
    delete: async (id) => {
        // Deletes entity of given id from db table
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        const stmt = await db.prepare('SELECT * FROM question WHERE problem_id = @id',
            { '@id': id });

        let result = await stmt.all();
        await stmt.finalize();

        if (result.length > 0) {
            await db.close();
            throw new Error('At least one question is attached to this problem, so you can\'t delete it.');
        }

        result = await db.run('DELETE FROM problem_relation WHERE parent_id = @id OR child_id = @id',
            { '@id': id });

        result = await db.run('DELETE FROM problem WHERE id = @id',
            { '@id': id }); // Should this delete all relations related to the given problem?

        await db.close();
        return result;
    },
    exists: async (id) => {
        // Returns True if entity with given id exists in db table, false otherwise
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        const stmt = await db.prepare('SELECT * FROM problem WHERE id = @id',
            { '@id': id });

        let result = await stmt.get();
        await stmt.finalize();

        await db.close();
        return result != null;
    },
    count: async () => {
        // Returns total number of entities in db table
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        const stmt = await db.prepare('SELECT * FROM problem');

        let result = await stmt.all();
        await stmt.finalize();

        await db.close();
        return result.length;
    },
    findById: async (id) => {
        // Returns entity with given id from db table, null if not existent
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        var stmt = await db.prepare('SELECT * FROM problem WHERE id = @id', { '@id': id });
        let problem = await stmt.get();
        await stmt.finalize();

        await db.close()
        return problem;
    },
    getProblemsForDomain: async (id) => {
        // Returns all entities from db table
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        var stmt = await db.prepare('SELECT * FROM problem WHERE domain_id = @domain_id', { '@domain_id': id });
        let problems = await stmt.all();
        await stmt.finalize();

        await db.close()
        return problems;
    },
    getAll: async () => {
        // Returns all entities from db table
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        var stmt = await db.prepare('SELECT * FROM problem');
        let problems = await stmt.all();
        await stmt.finalize();

        await db.close()
        return problems;
    }
}

module.exports = repository;